<?php
class appSofortFrontendActions extends stActions 
{

    public function executeReturnSuccess() 
    {
        $this->smarty = new stSmarty($this->getModuleName());
    }

    public function executeReturnFail() 
    {
        $this->smarty = new stSmarty($this->getModuleName());
    }

    public function executeStatusReport() 
    {
        $body = file_get_contents('php://input');

        $sofort = new appSofort();

        try
        {
            $transaction = $sofort->verifyTransaction($body); 
        }
        catch (Exception $e)
        {
            $order = OrderPeer::retrieveByIdAndHashCode($this->getRequestParameter('id'), $this->getRequestParameter('hash'));

            if ($order) 
            {
                file_put_contents(sfConfig::get('sf_root_dir').'/log/sofort.txt', '['.date('d-m-Y H:i:s').']'.": [ORDER] ".$order->getNumber()."\n", FILE_APPEND);
            }   
            
            file_put_contents(sfConfig::get('sf_root_dir').'/log/sofort.txt', '['.date('d-m-Y H:i:s').']'.": ".$e->getMessage()."\n[BODY]:\n".var_export($body, true)."\n", FILE_APPEND);

            return $this->renderText($e->getMessage());
        }
      
        if (in_array($transaction->getStatus(), array('received', 'pending', 'untraceable')))
        {
            $order = OrderPeer::retrieveByIdAndHashCode($this->getRequestParameter('id'), $this->getRequestParameter('hash'));

            if ($order)
            {
                $payment = $order->getOrderPayment();

                if ($payment)
                {
                    $payment->setStatus(true);
                    $payment->save();
                }
            }
        }

        $output = array();

        $methods = array(
            'getAmount' => '',
            'getAmountRefunded' => '',
            'getCount' => '',
            'getPaymentMethod' => '',
            'getConsumerProtection' => '',
            'getStatus' => '',
            'getStatusReason' => '',
            'getStatusModifiedTime' => '',
            'getLanguageCode' => '',
            'getCurrency' => '',
            'getTransaction' => '',
            'getReason' => array(0,0),
            'getUserVariable' => 0,
            'getTime' => '',
            'getProjectId' => '',
            'getRecipientHolder' => '',
            'getRecipientAccountNumber' => '',
            'getRecipientBankCode' => '',
            'getRecipientCountryCode' => '',
            'getRecipientBankName' => '',
            'getRecipientBic' => '',
            'getRecipientIban' => '',
            'getSenderHolder' => '',
            'getSenderAccountNumber' => '',
            'getSenderBankCode' => '',
            'getSenderCountryCode' => '',
            'getSenderBankName' => '',
            'getSenderBic' => '',
            'getSenderIban' => '',
        );

        foreach($methods as $method => $params) 
        {
            if(count($params) == 2) 
            {
                $output[] = $method . ': ' . $transaction->$method($params[0], $params[1]);
            } 
            else if($params !== '') 
            {
                $output[] = $method . ': ' . $transaction->$method($params);
            } 
            else 
            {
                $output[] = $method . ': ' . $transaction->$method();
            }
        }

        return $this->renderText(implode('<br />', $output)); 
    }
}